{********************************************************
 * Demo3 application                                    *
 *                                                      *
 * This sample outline a simple acounting application   *
 * where in separate way of the main application is     *
 * possible to register the following optional modules: *
 *                                                      *
 *     1. General Ledger                                *
 *     2. Receivable                                    *
 *     3. Payable                                       *
 *     4. Utilities                                     *
 *                                                      *
 *     Part of the AVLock NET package                   *
 *     (c) Alcides Valega, 2003                         *
 ********************************************************}

unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, AVLockGold, StdCtrls, jpeg, ExtCtrls, shellapi, registry;

type
  TForm1 = class(TForm)
    MM1: TMainMenu;
    Modulo11: TMenuItem;
    Item111: TMenuItem;
    Item121: TMenuItem;
    Modulo21: TMenuItem;
    Item211: TMenuItem;
    Item221: TMenuItem;
    m1Opcin31: TMenuItem;
    Modulo31: TMenuItem;
    m3Opcin11: TMenuItem;
    m3Opcin21: TMenuItem;
    m3Opcin31: TMenuItem;
    Modulo41: TMenuItem;
    m4Opcin11: TMenuItem;
    m4Opcin21: TMenuItem;
    Archivos1: TMenuItem;
    Salir1: TMenuItem;
    LoggedUsers1: TMenuItem;
    Registration1: TMenuItem;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    AVLockGold1: TAVLockGold;
    LUserName: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LCompany: TLabel;
    LLocalCompany: TLabel;
    LLocalName: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Item111Click(Sender: TObject);
    procedure Item121Click(Sender: TObject);
    procedure m1Opcin31Click(Sender: TObject);
    procedure Item211Click(Sender: TObject);
    procedure Item221Click(Sender: TObject);
    procedure m3Opcin11Click(Sender: TObject);
    procedure m3Opcin21Click(Sender: TObject);
    procedure m3Opcin31Click(Sender: TObject);
    procedure m4Opcin11Click(Sender: TObject);
    procedure m4Opcin21Click(Sender: TObject);
    procedure Salir1Click(Sender: TObject);
    procedure Registration1Click(Sender: TObject);
    procedure LoggedUsers1Click(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure settext;
    Procedure setmodules;
    function MyExecute(force:boolean):boolean;
    procedure legend(m,i:integer);
  end;

var
  Form1: TForm1;
  txt  : string;

implementation
uses RegUnit3;
{$R *.DFM}

procedure TForm1.settext;
begin
  if avlockgold1.Registered then  txt:='Registered to : '
  else if avlockgold1.Authorized then txt:='Authorized to : '
  else  txt:='Trial period to : ';
  Label5.caption:=txt;
  LUserName.caption:=avlockgold1.RegUserName;
  LCompany.caption:=avlockgold1.Company;

  LLocalName.caption:=avlockgold1.LocalUserName;
  LLocalCompany.caption:=avlockgold1.LocalCompany;
end;


Procedure TForm1.setmodules;
begin
  MM1.Items[1].visible := AVLockGold1.moduleok(1);
  MM1.Items[2].visible := AVLockGold1.moduleok(2);
  MM1.Items[3].visible := AVLockGold1.moduleok(3);
  MM1.Items[4].visible := AVLockGold1.moduleok(4);
end;

function TForm1.MyExecute(force:boolean):boolean;
var F:TRegForm1;
begin
  Result:=False;
  with avlockgold1 do begin
    read;
    setmodules;
    MakeTrial;
    writelastdate;
    result:= NotShow;
    if not result or force then begin
      F:=TRegForm1.Create(nil);
      try
      F.Caption:=AppName;
      F.EdICode.Text:=Installcode;
      F.BtnOk.Enabled:=not expired;
      F.memo3.Font :=avlockgold1.Font;

      F.Lexpire.caption:=GetText1;
      F.memo1.lines.add(GetText2);
      //show installcode
      F.Panel2.visible:= not (User_Name in AVLockGold1.InstallCodeSources);

      F.onlinetxt:=OnlineLink;
      F.emailtxt:='mailto:'+EmailAddress+'?Subject='+AppName+
      ' Registration &Body='+'%0D%0AUser Name : '+RegUserName+
      '%0D%0ACompany : '+Company;
      if F.Panel2.Visible then F.emailtxt:=F.emailtxt+'%0D%0AInstall Code : '+InstallCode;
      F.emailtxt:=F.emailtxt+'%0D%0A%0D%0A__________________________________________________'+
      '%0D%0APlease send this email as is or change the user name %0D%0Aand company with the values that you want to register.';

      if (AccessMode=2) then begin  //MasterComputer
        F.P1.Hide;
        F.P2.Show;
      end else begin //RegularComputer
        F.P2.Hide;
        F.P1.Show;
      end;
      F.ClientWidth:=F.BtnOk.Left+F.btnOk.Width+15;
      F.ClientHeight:=F.Panel5.Top+F.Panel5.Height+15;

      F.ShowModal;
      if F.modalresult = mrYes then begin //The Register button has been pressed
        if (AccessMode=2) //MasterComputer
        then result:=DoMasterReg(F.Memo3.lines,F.EdName.Text,F.EdCompany.text)
        else result:=DoRegularReg(F.Edit1.text,F.Edit2.text);//RegularComputer
      end else if (F.modalresult = mrOk) then Result:=True;
      finally
        F.Free;
      end;
      Active := True;
      Refresh;
      SetModules;
    end;
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  if not myExecute(false) then application.Terminate;
  settext;
end;

procedure TForm1.legend(m,i:integer);
begin
  showmessage('Module: '+inttostr(m)+'       Item: '+inttostr(i)+#13#10+
  '--------------------------------------------'+#13#10+
  'Registered to : '+avlockgold1.RegUserName+#13+
  'Company        : '+avlockgold1.Company+#13+
  '--------------------------------------------'+#13#10+
  'Sample program using the AVLock component');
end;

procedure TForm1.Item111Click(Sender: TObject);
begin
  legend(1,1);
end;

procedure TForm1.Item121Click(Sender: TObject);
begin
  legend(1,2);
end;

procedure TForm1.m1Opcin31Click(Sender: TObject);
begin
  legend(1,3);
end;

procedure TForm1.Item211Click(Sender: TObject);
begin
  legend(2,1);
end;

procedure TForm1.Item221Click(Sender: TObject);
begin
  legend(2,2);
end;

procedure TForm1.m3Opcin11Click(Sender: TObject);
begin
  legend(3,1);
end;

procedure TForm1.m3Opcin21Click(Sender: TObject);
begin
  legend(3,2);
end;

procedure TForm1.m3Opcin31Click(Sender: TObject);
begin
  legend(3,3);
end;

procedure TForm1.m4Opcin11Click(Sender: TObject);
begin
  legend(4,1);
end;

procedure TForm1.m4Opcin21Click(Sender: TObject);
begin
  legend(4,2);
end;

procedure TForm1.Salir1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Registration1Click(Sender: TObject);
begin
  myexecute(true);
  settext;
end;

procedure TForm1.LoggedUsers1Click(Sender: TObject);
var s:string;
    i:integer;
begin
  if (avlockgold1.MaxUsers=0) then begin
    showmessage('Not allowed when MaxUsers=0');
    exit;
  end;
  avlockgold1.Refresh;
  s:='Registered to : '+avlockgold1.RegUserName+#13+
     'Company        : '+avlockgold1.Company+#13
  +'----------------------------------------------------------'+#13
  +'There are active '+inttostr(avlockgold1.activeusers.count)+' of '+inttostr(avlockgold1.maxusers)+' allowed users'+#13
  +'----------------------------------------------------------'+#13;
  for i:=0 to avlockgold1.activeusers.count -1
  do s:=s+avlockgold1.activeusers[i]+#13;
  s:=s+'----------------------------------------------------------';
  showmessage(s);
end;

procedure TForm1.Label1Click(Sender: TObject);
begin
  ShellExecute(0, 'open',
  Pchar('https://secure.element5.com/shareit/checkout.html?productid=172879&language=English'),
  nil, nil, SW_SHOWMAXIMIZED);
end;

procedure TForm1.Label2Click(Sender: TObject);
begin
  ShellExecute(0, 'open',
  Pchar('https://secure.element5.com/shareit/checkout.html?productid=172880&language=English'),
  nil, nil, SW_SHOWMAXIMIZED);
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  ShellExecute(0, 'open',
  Pchar('http://www.avsoft.sitio.net'),
  nil, nil, SW_SHOWMAXIMIZED);
end;

end.
